unit U_volinf;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils,
  CalMis16, CALVOL16,
  U_Vars, Gauges;

type
  TVolumeInfo = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Bevel1: TBevel;
    VolumeList: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    CheckBoxRemovable: TCheckBox;
    EditEntries: TEdit;
    EditBlocks: TEdit;
    GaugeEntries: TGauge;
    GaugeBlocks: TGauge;
    procedure FormShow(Sender: TObject);
    procedure VolumeListClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  VolumeInfo: TVolumeInfo;
  VolList:    Array[0..255] of nuint16;

implementation

{$R *.DFM}

procedure TVolumeInfo.FormShow(Sender: TObject);
Var
   volNum :              nuint16;
   volName :             String;
   totalBlocks :         nuint16;
   sectorsPerBlock :     nuint16;
   availableBlocks :     nuint16;
   totalDirEntries :     nuint16;
   availableDirEntries : nuint16;
   volIsRemovableFlag :  nuint16;
   index :               nuint16;

begin
   While (VolumeList.Items.Count>0) DO VolumeList.Items.Delete(0);  { First Clean Up }

   index := 0;
   for volNum := 0 to 255 do begin  { scan all volumes }
       cCode := NWGetVolumeInfoWithNumber(connHandle, volNum,
                @volName[1], @totalBlocks, @sectorsPerBlock, @availableBlocks,
                @totalDirEntries, @availableDirEntries, @volIsRemovableFlag);
       if (cCode=0) and (StrLen(@volName[1])>0) then begin
          VolumeList.Items.Add(StrPas(@volName[1]));
          VolList[index] := volNum;  { store index - VolNum relation }
          inc(index);
          end;
       end;
   If (VolumeList.ItemIndex=-1) and (VolumeList.Items.Count>0)
      then VolumeList.ItemIndex := 0;  { select first volume }
end;

procedure TVolumeInfo.VolumeListClick(Sender: TObject);
Var
   volNum :              nuint16;
   volName :             String;
   totalBlocks :         nuint16;
   sectorsPerBlock :     nuint16;
   availableBlocks :     nuint16;
   totalDirEntries :     nuint16;
   availableDirEntries : nuint16;
   volIsRemovableFlag :  nuint16;
   index :               nuint16;
begin
   cCode := NWGetVolumeInfoWithNumber(connHandle, VolList[VolumeList.ItemIndex],
                @volName[1], @totalBlocks, @sectorsPerBlock, @availableBlocks,
                @totalDirEntries, @availableDirEntries, @volIsRemovableFlag);
   if (cCode=0) and (StrLen(@volName[1])>0) then begin
          EditBlocks.Text       := IntToStr(totalBlocks-availableBlocks) + ' / ' + IntToStr(totalBlocks);
          GaugeBlocks.MaxValue  := totalBlocks;
          GaugeBlocks.Progress  := totalBlocks-availableBlocks;
          EditEntries.Text      := IntToStr(totalDirEntries-availableDirEntries)+ ' / ' + IntToStr(totalDirEntries);
          GaugeEntries.MaxValue := totalDirEntries;
          GaugeEntries.Progress := totalDirEntries-availableDirEntries;
          CheckBoxRemovable.Checked := volIsRemovableFlag>0;
          end;
   If (VolumeList.ItemIndex=-1) and (VolumeList.Items.Count>0)
      then VolumeList.ItemIndex := 0;
end;

end.
